stages:
  - compile
  - compile-test
  - test

sources:
  stage: compile
  image: maven:3.9.9-eclipse-temurin-17
  cache:
    - key:
        files:
          - pom.xml
      paths:
        - .m2/repository
  script:
    - mvn -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository resources:resources compiler:compile
  artifacts:
    expire_in: 30 mins
    paths:
      - target/classes
      - target/generated-sources
      - target/maven-status
test-sources:
  dependencies:
    - sources
  stage: compile-test
  image: maven:3.9.9-eclipse-temurin-17
  cache:
    - key:
        files:
          - pom.xml
      paths:
        - .m2/repository
  script:
    - mvn -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository resources:testResources compiler:testCompile
  artifacts:
    expire_in: 30 mins
    paths:
      - target/generated-test-sources
      - target/test-classes
unit-test:
  dependencies:
    - sources
    - test-sources
  stage: test
  image: maven:3.9.9-eclipse-temurin-17
  cache:
    - key:
        files:
          - pom.xml
      paths:
        - .m2/repository
  script:
    - mvn -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository surefire:test
coverage:
  stage: test
  dependencies:
    - sources
    - test-sources
  image: maven:3.9.9-eclipse-temurin-17
  cache:
    - key:
        files:
          - pom.xml
      paths:
        - .m2/repository
  script:
    - mvn -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository jacoco:prepare-agent surefire:test jacoco:check@coverage jacoco:report
    # Print total coverage to log so it can be extracted by the coverage regex
    - 'cd target/site/jacoco/'
    - awk -F"," '{ instructions += $4 + $5; covered += $5 } END { print covered, "/", instructions, " instructions covered"; print "Coverage:", int(100*covered/instructions), "%" }' jacoco.csv
  artifacts:
    expire_in: 30 mins
    paths:
      - target/site/jacoco
  coverage: '/Coverage:.*?([0-9]{1,3}) %/'
